diff --git a/scripts/gcc-plugins/rap_plugin/rap_ret_pass.c b/scripts/gcc-plugins/rap_plugin/rap_ret_pass.c
new file mode 100644
index 000000000000..3575980c3d8e
--- /dev/null
+++ b/scripts/gcc-plugins/rap_plugin/rap_ret_pass.c
@@ -0,0 +1,358 @@
+/*
+ * Copyright 2012-2017 by PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Homepage: http://pax.grsecurity.net/
+ */
+
+#include "rap.h"
+
+bool rap_cmodel_check(void)
+{
+#ifdef TARGET_386
+	tree section;
+
+	if (!TARGET_64BIT || ix86_cmodel != CM_KERNEL)
+		return true;
+
+	section = lookup_attribute("section", DECL_ATTRIBUTES(current_function_decl));
+	if (!section || !TREE_VALUE(section))
+		return true;
+
+	section = TREE_VALUE(TREE_VALUE(section));
+	return strncmp(TREE_STRING_POINTER(section), ".vsyscall_", 10);
+#else
+#error unsupported target
+#endif
+}
+
+static bool rap_ret_gate(void)
+{
+	return rap_cmodel_check();
+}
+
+tree create_new_var(tree type, const char *name)
+{
+	tree var;
+
+	var = create_tmp_var(type, name);
+	add_referenced_var(var);
+//	mark_sym_for_renaming(var);
+	return var;
+}
+
+/*
+ * insert the equivalent of
+ * return (unsigned long)__builtin_return_address(0);
+ */
+static tree get_retaddr(gimple_seq *stmts)
+{
+	gimple stmt;
+	tree retaddr_ptr;
+
+	stmt = barrier(NULL_TREE, true);
+	gimple_seq_add_stmt(stmts, stmt);
+
+	// copy the return address into a temporary variable
+	retaddr_ptr = create_new_var(ptr_type_node, "rap_retaddr_exit_ptr");
+	stmt = gimple_build_call(builtin_decl_implicit(BUILT_IN_RETURN_ADDRESS), 1, integer_zero_node);
+	retaddr_ptr = make_ssa_name(retaddr_ptr, stmt);
+	gimple_call_set_lhs(stmt, retaddr_ptr);
+	gimple_seq_add_stmt(stmts, stmt);
+
+	return retaddr_ptr;
+}
+
+/*
+ * insert the equivalent of
+ * if (*(long *)((void *)retaddr+N) != (long)-function_hash) abort();
+ */
+static void check_retaddr(gimple_stmt_iterator *gsi, tree new_retaddr)
+{
+	gimple stmt;
+	location_t loc;
+	basic_block cond_bb, join_bb, true_bb;
+	edge e;
+
+	gcc_assert(!gsi_end_p(*gsi));
+	loc = gimple_location(gsi_stmt(*gsi));
+
+	gimple_seq stmts = NULL;
+	tree target_hash, computed_hash;
+	rap_hash_t hash;
+
+#ifdef TARGET_386
+	if (TARGET_64BIT)
+		target_hash = get_rap_hash(&stmts, loc, new_retaddr, -16);
+	else
+		target_hash = get_rap_hash(&stmts, loc, new_retaddr, -10);
+#else
+#error unsupported target
+#endif
+
+	if (gsi_end_p(*gsi) || !stmt_ends_bb_p(gsi_stmt(*gsi)))
+		gsi_insert_seq_after(gsi, stmts, GSI_CONTINUE_LINKING);
+	else {
+		gsi_insert_seq_before(gsi, stmts, GSI_SAME_STMT);
+		gsi_prev(gsi);
+	}
+
+	hash = rap_hash_function_type(TREE_TYPE(current_function_decl), imprecise_rap_hash_flags);
+	computed_hash = build_int_cst_type(rap_hash_type_node, -hash.hash);
+
+	stmt = gimple_build_cond(NE_EXPR, target_hash, computed_hash, NULL_TREE, NULL_TREE);
+	gimple_set_location(stmt, loc);
+	gsi_insert_after(gsi, stmt, GSI_CONTINUE_LINKING);
+
+	cond_bb = gimple_bb(gsi_stmt(*gsi));
+	e = split_block(cond_bb, gsi_stmt(*gsi));
+	cond_bb = e->src;
+	join_bb = e->dest;
+	e->flags = EDGE_FALSE_VALUE;
+	e->probability = REG_BR_PROB_BASE;
+
+	true_bb = create_empty_bb(join_bb);
+	make_edge(cond_bb, true_bb, EDGE_TRUE_VALUE | EDGE_PRESERVE);
+
+	set_immediate_dominator(CDI_DOMINATORS, true_bb, cond_bb);
+	set_immediate_dominator(CDI_DOMINATORS, join_bb, cond_bb);
+
+	gcc_assert(cond_bb->loop_father == join_bb->loop_father);
+	add_bb_to_loop(true_bb, cond_bb->loop_father);
+
+	// insert call to builtin_trap or rap_abort_ret
+	*gsi = gsi_start_bb(true_bb);
+
+	if (report_runtime) {
+		VEC(tree, gc) *inputs = NULL;
+		tree input;
+
+		// build the equivalence of asm volatile ("" : : "cx"(__builtin_return_address(0)));
+		input = build_tree_list(NULL_TREE, build_const_char_string(3, "cx"));
+		input = chainon(NULL_TREE, build_tree_list(input, new_retaddr));
+		VEC_safe_push(tree, gc, inputs, input);
+
+		stmt = gimple_build_asm_vec("", inputs, NULL, NULL, NULL);
+		gimple_asm_set_volatile(as_a_gasm(stmt), true);
+		gimple_set_location(stmt, loc);
+		gsi_insert_after(gsi, stmt, GSI_CONTINUE_LINKING);
+	}
+
+	if (rap_abort_ret) {
+		stmt = gimple_build_asm_vec(rap_abort_ret, NULL, NULL, NULL, NULL);
+		gimple_asm_set_volatile(as_a_gasm(stmt), true);
+		gimple_set_location(stmt, loc);
+		gsi_insert_after(gsi, stmt, GSI_CONTINUE_LINKING);
+
+		stmt = gimple_build_call(builtin_decl_implicit(BUILT_IN_UNREACHABLE), 0);
+	} else
+		stmt = gimple_build_call(builtin_decl_implicit(BUILT_IN_TRAP), 0);
+
+	gimple_set_location(stmt, loc);
+	gsi_insert_after(gsi, stmt, GSI_CONTINUE_LINKING);
+
+	*gsi = gsi_after_labels(join_bb);
+}
+
+static unsigned int rap_ret_execute(void)
+{
+	edge e;
+	edge_iterator ei;
+
+	loop_optimizer_init(LOOPS_NORMAL | LOOPS_HAVE_RECORDED_EXITS);
+	gcc_assert(current_loops);
+
+	calculate_dominance_info(CDI_DOMINATORS);
+	calculate_dominance_info(CDI_POST_DOMINATORS);
+
+	FOR_EACH_EDGE(e, ei, EXIT_BLOCK_PTR_FOR_FN(cfun)->preds) {
+		gimple_stmt_iterator gsi;
+		gimple_seq stmts = NULL;
+		tree new_retaddr;
+
+		gsi = gsi_last_nondebug_bb(e->src);
+		gcc_assert(!gsi_end_p(gsi));
+		gcc_assert(gimple_code(gsi_stmt(gsi)) == GIMPLE_RETURN);
+
+		new_retaddr = get_retaddr(&stmts);
+		gsi_insert_seq_before(&gsi, stmts, GSI_SAME_STMT);
+		gsi_prev(&gsi);
+		check_retaddr(&gsi, new_retaddr);
+	}
+
+	free_dominance_info(CDI_DOMINATORS);
+	free_dominance_info(CDI_POST_DOMINATORS);
+	loop_optimizer_finalize();
+	return 0;
+}
+
+#define PASS_NAME rap_ret
+#define PROPERTIES_REQUIRED PROP_cfg
+#define TODO_FLAGS_FINISH TODO_verify_ssa | TODO_verify_stmts | TODO_dump_func | TODO_remove_unused_locals | TODO_update_ssa | TODO_cleanup_cfg | TODO_ggc_collect | TODO_rebuild_cgraph_edges | TODO_verify_flow
+#include "gcc-generate-gimple-pass.h"
+
+// find and remove the asm mark from the given insn up in its basic block
+static tree rap_find_retloc_mark(rtx_insn *insn)
+{
+	basic_block bb;
+	rtx_insn *hash;
+
+#if BUILDING_GCC_VERSION == 4005
+	FOR_EACH_BB_FN(bb, cfun) {
+		rtx_insn *i;
+
+		FOR_BB_INSNS(bb, i) {
+			if (i == insn)
+				break;
+		}
+		if (i == insn)
+			break;
+	}
+#else
+	bb = BLOCK_FOR_INSN(insn);
+#endif
+	gcc_assert(bb);
+	gcc_assert(BB_HEAD(bb));
+
+	for (hash = insn; hash && hash != PREV_INSN(BB_HEAD(bb)); hash = PREV_INSN(hash)) {
+		tree computed_hash;
+		rtx body;
+
+		if (!INSN_P(hash))
+			continue;
+
+		body = PATTERN(hash);
+
+		if (GET_CODE(body) != PARALLEL)
+			continue;
+
+		body = XVECEXP(body, 0, 0);
+		if (GET_CODE(body) != ASM_OPERANDS)
+			continue;
+
+		if (ASM_OPERANDS_INPUT_LENGTH(body) != 1)
+			continue;
+
+		body = ASM_OPERANDS_INPUT(body, 0);
+		if (!CONST_INT_P(body))
+			continue;
+
+		computed_hash = build_int_cst_type(rap_hash_type_node, INTVAL(body));
+		delete_insn_and_edges(hash);
+		return computed_hash;;
+	}
+
+	return NULL_TREE;
+}
+
+static tree rap_get_direct_call_retloc_mark(rtx_insn *insn)
+{
+	rap_hash_t func_hash;
+	rtx body;
+	tree fntype;
+
+	body = PATTERN(insn);
+	if (GET_CODE(body) == SET)
+		body = SET_SRC(body);
+	if (GET_CODE(body) != CALL)
+		return NULL_TREE;
+
+	body = XEXP(body, 0);
+	gcc_assert(GET_CODE(body) == MEM);
+	if (GET_CODE(XEXP(body, 0)) != SYMBOL_REF)
+		return NULL_TREE;
+
+	fntype = SYMBOL_REF_DECL(XEXP(body, 0));
+	gcc_assert(TREE_CODE(fntype) == FUNCTION_DECL);
+	fntype = TREE_TYPE(fntype);
+	func_hash = rap_hash_function_type(fntype, imprecise_rap_hash_flags);
+	return build_int_cst_type(rap_hash_type_node, -func_hash.hash);
+}
+
+static unsigned int rap_mark_retloc_execute(void)
+{
+	rtx_insn *insn;
+
+	for (insn = get_insns(); insn; insn = NEXT_INSN(insn)) {
+		rtvec argvec, constraintvec, labelvec;
+		rtx mark, label1, label2;
+		tree computed_hash = NULL_TREE;
+
+		if (INSN_DELETED_P(insn))
+			continue;
+
+		// rtl match (call_insn (set (reg) (call (mem))))
+		if (!CALL_P(insn))
+			continue;
+
+		gcc_assert(!SIBLING_CALL_P(insn));
+
+		if (find_reg_note(insn, REG_NORETURN, 0))
+			continue;
+
+		argvec = rtvec_alloc(1);
+		constraintvec = rtvec_alloc(1);
+		labelvec = rtvec_alloc(2);
+
+#ifdef TARGET_386
+		if (TARGET_64BIT)
+			mark = gen_rtx_ASM_OPERANDS(VOIDmode, ggc_strdup("jmp %l1 ; .quad %c0 ; .skip 8-(%l2-%l1),0xcc"), empty_string, 0, argvec, constraintvec, labelvec, INSN_LOCATION(insn));
+		else
+			mark = gen_rtx_ASM_OPERANDS(VOIDmode, ggc_strdup("jmp %l1 ; .long %c0 ; .skip 6-(%l2-%l1),0xcc"), empty_string, 0, argvec, constraintvec, labelvec, INSN_LOCATION(insn));
+#else
+#error unsupported target
+#endif
+		MEM_VOLATILE_P(mark) = 1;
+
+		computed_hash = rap_find_retloc_mark(insn);
+
+		// gcc can insert calls to memcpy/memmove/etc in RTL
+		if (!computed_hash)
+			computed_hash = rap_get_direct_call_retloc_mark(insn);
+
+		// due to optimizations, the return location mark(s) could have ended up in preceding blocks
+		if (!computed_hash) {
+			edge e;
+			edge_iterator ei;
+			tree h;
+
+			FOR_EACH_EDGE(e, ei, BLOCK_FOR_INSN(insn)->preds) {
+				gcc_assert(single_succ_p(e->src));
+				h = rap_find_retloc_mark(BB_END(e->src));
+				gcc_assert(h);
+
+				if (computed_hash)
+					gcc_assert(tree_to_shwi(h) == tree_to_shwi(computed_hash));
+				else
+					computed_hash = h;
+			}
+		}
+
+		gcc_assert(computed_hash);
+		ASM_OPERANDS_INPUT(mark, 0) = expand_expr(computed_hash, NULL_RTX, VOIDmode, EXPAND_INITIALIZER);
+
+		ASM_OPERANDS_INPUT_CONSTRAINT_EXP(mark, 0) = gen_rtx_ASM_INPUT_loc(DImode, ggc_strdup("i"), UNKNOWN_LOCATION);
+
+		label1 = gen_label_rtx();
+		label2 = gen_label_rtx();
+		ASM_OPERANDS_LABEL(mark, 0) = label1;
+		ASM_OPERANDS_LABEL(mark, 1) = label2;
+
+		emit_insn_before(mark, insn);
+
+		emit_label_before(label1, insn);
+		LABEL_NUSES(label1)++;
+		do {
+			insn = NEXT_INSN(insn);
+		} while (GET_CODE(insn) == NOTE && NOTE_KIND(insn) == NOTE_INSN_CALL_ARG_LOCATION);
+		emit_label_before(label2, insn);
+		LABEL_NUSES(label2)++;
+	}
+
+	return 0;
+}
+
+#define PASS_NAME rap_mark_retloc
+#define NO_GATE
+#define TODO_FLAGS_FINISH TODO_dump_func | TODO_verify_rtl_sharing
+#include "gcc-generate-rtl-pass.h"
diff --git a/scripts/gcc-plugins/rap_plugin/sip.c b/scripts/gcc-plugins/rap_plugin/sip.c
new file mode 100644
index 000000000000..65bc1cdea580
--- /dev/null
+++ b/scripts/gcc-plugins/rap_plugin/sip.c
@@ -0,0 +1,96 @@
+// SipHash-2-4 adapted by the PaX Team from the public domain version written by
+//   Jean-Philippe Aumasson <jeanphilippe.aumasson@gmail.com>
+//   Daniel J. Bernstein <djb@cr.yp.to>
+
+#include <stdint.h>
+
+#define ROTL(x, b) (u64)(((x) << (b)) | ((x) >> (64 - (b))))
+
+#define U32TO8_LE(p, v)						\
+	(p)[0] = (u8)((v)      ); (p)[1] = (u8)((v) >>  8);	\
+	(p)[2] = (u8)((v) >> 16); (p)[3] = (u8)((v) >> 24);
+
+#define U64TO8_LE(p, v)				\
+	U32TO8_LE((p),     (u32)((v)      ));	\
+	U32TO8_LE((p) + 4, (u32)((v) >> 32));
+
+#define U8TO64_LE(p)	(	\
+	((u64)((p)[0])      ) |	\
+	((u64)((p)[1]) <<  8) |	\
+	((u64)((p)[2]) << 16) |	\
+	((u64)((p)[3]) << 24) |	\
+	((u64)((p)[4]) << 32) |	\
+	((u64)((p)[5]) << 40) |	\
+	((u64)((p)[6]) << 48) |	\
+	((u64)((p)[7]) << 56))
+
+#define SIPROUND							\
+do {									\
+	v0 += v1; v1 = ROTL(v1, 13); v1 ^= v0; v0 = ROTL(v0, 32);	\
+	v2 += v3; v3 = ROTL(v3, 16); v3 ^= v2;				\
+	v0 += v3; v3 = ROTL(v3, 21); v3 ^= v0;				\
+	v2 += v1; v1 = ROTL(v1, 17); v1 ^= v2; v2 = ROTL(v2, 32);	\
+} while(0)
+
+typedef uint64_t u64;
+typedef uint32_t u32;
+typedef uint8_t u8;
+
+/* SipHash-2-4 with previous output folding, a poor man's streaming interface */
+void siphash24fold(unsigned char *out, const unsigned char *in, unsigned long long inlen, const unsigned char *k);
+
+void siphash24fold(unsigned char *out, const unsigned char *in, unsigned long long inlen, const unsigned char *k)
+{
+	u64 k0 = U8TO64_LE(k);
+	u64 k1 = U8TO64_LE(k + 8);
+	/* "somepseudorandomlygeneratedbytes" */
+	u64 v0 = 0x736f6d6570736575ULL ^ k0;
+	u64 v1 = 0x646f72616e646f6dULL ^ k1;
+	u64 v2 = 0x6c7967656e657261ULL ^ k0;
+	u64 v3 = 0x7465646279746573ULL ^ k1;
+	u64 b, m;
+	const u8 * const end = in + inlen - (inlen % sizeof(u64));
+	const int left = inlen & 7;
+	b = ((u64)inlen) << 56;
+
+	// fold in the previous output
+	m = U8TO64_LE(out);
+	v3 ^= m;
+	SIPROUND;
+	SIPROUND;
+	v0 ^= m;
+
+	// consume full input blocks
+	for (; in != end; in += 8) {
+		m = U8TO64_LE(in);
+		v3 ^= m;
+		SIPROUND;
+		SIPROUND;
+		v0 ^= m;
+	}
+
+	// consume the last potentially partial block
+	switch (left) {
+	case 7: b |= ((u64)in[6]) << 48;
+	case 6: b |= ((u64)in[5]) << 40;
+	case 5: b |= ((u64)in[4]) << 32;
+	case 4: b |= ((u64)in[3]) << 24;
+	case 3: b |= ((u64)in[2]) << 16;
+	case 2: b |= ((u64)in[1]) <<  8;
+	case 1: b |= ((u64)in[0]); break;
+	case 0: break;
+	}
+
+	// finalize
+	v3 ^= b;
+	SIPROUND;
+	SIPROUND;
+	v0 ^= b;
+	v2 ^= 0xff;
+	SIPROUND;
+	SIPROUND;
+	SIPROUND;
+	SIPROUND;
+	b = v0 ^ v1 ^ v2 ^ v3;
+	U64TO8_LE(out, b);
+}
diff --git a/scripts/gcc-plugins/sancov_plugin.c b/scripts/gcc-plugins/sancov_plugin.c
index 7ea0b3f50739..111e99d2e76c 100644
--- a/scripts/gcc-plugins/sancov_plugin.c
+++ b/scripts/gcc-plugins/sancov_plugin.c
@@ -1,5 +1,5 @@
 /*
- * Copyright 2011-2016 by Emese Revfy <re.emese@gmail.com>
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
  * Licensed under the GPL v2, or (at your option) v3
  *
  * Homepage:
@@ -62,6 +62,7 @@ static unsigned int sancov_execute(void)
 
 #include "gcc-generate-gimple-pass.h"
 
+#if BUILDING_GCC_VERSION < 6000
 static void sancov_start_unit(void __unused *gcc_data, void __unused *user_data)
 {
 	tree leaf_attr, nothrow_attr;
@@ -85,11 +86,11 @@ static void sancov_start_unit(void __unused *gcc_data, void __unused *user_data)
 	decl_attributes(&sancov_fndecl, leaf_attr, 0);
 #endif
 }
+#endif
 
 __visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
 {
 	int i;
-	struct register_pass_info sancov_plugin_pass_info;
 	const char * const plugin_name = plugin_info->base_name;
 	const int argc = plugin_info->argc;
 	const struct plugin_argument * const argv = plugin_info->argv;
@@ -107,17 +108,14 @@ __visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gc
 	};
 
 	/* BBs can be split afterwards?? */
-	sancov_plugin_pass_info.pass				= make_sancov_pass();
 #if BUILDING_GCC_VERSION >= 4009
-	sancov_plugin_pass_info.reference_pass_name		= "asan";
+	PASS_INFO(sancov, "asan", 0, PASS_POS_INSERT_BEFORE);
 #else
-	sancov_plugin_pass_info.reference_pass_name		= "nrv";
+	PASS_INFO(sancov, "nrv", 1, PASS_POS_INSERT_BEFORE);
 #endif
-	sancov_plugin_pass_info.ref_pass_instance_number	= 0;
-	sancov_plugin_pass_info.pos_op				= PASS_POS_INSERT_BEFORE;
 
 	if (!plugin_default_version_check(version, &gcc_version)) {
-		error(G_("incompatible gcc/plugin versions"));
+		error_gcc_version(version);
 		return 1;
 	}
 
@@ -126,7 +124,7 @@ __visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gc
 			enable = false;
 			continue;
 		}
-		error(G_("unkown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
 	}
 
 	register_callback(plugin_name, PLUGIN_INFO, NULL, &sancov_plugin_info);
@@ -137,7 +135,7 @@ __visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gc
 #if BUILDING_GCC_VERSION < 6000
 	register_callback(plugin_name, PLUGIN_START_UNIT, &sancov_start_unit, NULL);
 	register_callback(plugin_name, PLUGIN_REGISTER_GGC_ROOTS, NULL, (void *)&gt_ggc_r_gt_sancov);
-	register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &sancov_plugin_pass_info);
+	register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &sancov_pass_info);
 #endif
 
 	return 0;
diff --git a/scripts/gcc-plugins/size_overflow_plugin/.gitignore b/scripts/gcc-plugins/size_overflow_plugin/.gitignore
new file mode 100644
index 000000000000..36211fb36bb2
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/.gitignore
@@ -0,0 +1,2 @@
+disable.h
+e_*.h
diff --git a/scripts/gcc-plugins/size_overflow_plugin/Makefile b/scripts/gcc-plugins/size_overflow_plugin/Makefile
new file mode 100644
index 000000000000..a8039b2baf5e
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/Makefile
@@ -0,0 +1,22 @@
+HOST_EXTRACXXFLAGS += $(call hostcc-option, -fno-ipa-icf)
+
+$(HOSTLIBS)-$(CONFIG_PAX_SIZE_OVERFLOW) += size_overflow_plugin.so
+always := $($(HOSTLIBS)-y)
+
+size_overflow_plugin-objs := $(patsubst $(srctree)/$(src)/%.c,%.o,$(wildcard $(srctree)/$(src)/*.c))
+
+quiet_cmd_build_size_overflow_hash = GENHASH  $@
+      cmd_build_size_overflow_hash = \
+	$(CONFIG_SHELL) $(srctree)/$(src)/generate_size_overflow_hash.sh -s $(patsubst e_%,%,$(patsubst $(obj)/%.h,%,$@))_hash -d $< -o $@
+
+define build_size_overflow_hash
+targets += $(addsuffix .h,$(1))
+$(srctree)/$(src)/size_overflow_plugin_hash.c: $(addprefix $(obj)/,$(addsuffix .h,$(1)))
+$(addprefix $(obj)/,$(addsuffix .h,$(1))): $(addprefix $(src)/,$(addsuffix .data,$(1)))
+	$$(call if_changed,build_size_overflow_hash)
+endef
+
+size_overflow_hash_tables := e_fns e_fields e_fptrs e_vars e_aux disable
+$(foreach h,$(size_overflow_hash_tables),$(eval $(call build_size_overflow_hash,$(h))))
+
+clean-files += *.so
diff --git a/scripts/gcc-plugins/size_overflow_plugin/e_aux.data b/scripts/gcc-plugins/size_overflow_plugin/e_aux.data
new file mode 100644
index 000000000000..74e91b2a19cf
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/e_aux.data
@@ -0,0 +1,97 @@
+enable_so_spa_set_aux_vdevs_fndecl_746 spa_set_aux_vdevs fndecl 3 746 NULL
+enable_so_zfs_lookup_fndecl_2144 zfs_lookup fndecl 0 2144 NULL
+enable_so_mappedread_fndecl_2627 mappedread fndecl 2 2627 NULL
+enable_so_SMACL_Alloc_fndecl_2775 SMACL_Alloc fndecl 1 2775 NULL
+enable_so_vdev_disk_dio_alloc_fndecl_2957 vdev_disk_dio_alloc fndecl 1 2957 NULL
+enable_so_nv_alloc_pushpage_spl_fndecl_4286 nv_alloc_pushpage_spl fndecl 2 4286 NULL
+enable_so_zpl_xattr_get_fndecl_4574 zpl_xattr_get fndecl 0 4574 NULL
+enable_so_sa_replace_all_by_template_fndecl_5699 sa_replace_all_by_template fndecl 3 5699 NULL
+enable_so_dmu_write_fndecl_6048 dmu_write fndecl 4-3 6048 NULL
+enable_so_dmu_buf_hold_array_fndecl_6095 dmu_buf_hold_array fndecl 4-3 6095 NULL
+enable_so_update_pages_fndecl_6225 update_pages fndecl 2-3 6225 NULL
+enable_so_bio_nr_pages_fndecl_7117 bio_nr_pages fndecl 0-2 7117 NULL
+enable_so_dmu_buf_hold_array_by_bonus_fndecl_8562 dmu_buf_hold_array_by_bonus fndecl 3-2 8562 NULL
+enable_so_zpios_dmu_write_fndecl_8858 zpios_dmu_write fndecl 4-5 8858 NULL
+enable_so_ddi_copyout_fndecl_9401 ddi_copyout fndecl 3 9401 NULL
+enable_so_avl_numnodes_fndecl_12384 avl_numnodes fndecl 0 12384 NULL
+enable_so_dmu_write_uio_dnode_fndecl_12473 dmu_write_uio_dnode fndecl 3 12473 NULL
+enable_so_dmu_xuio_init_fndecl_12866 dmu_xuio_init fndecl 2 12866 NULL
+enable_so_zpl_read_common_fndecl_14389 zpl_read_common fndecl 0 14389 NULL
+enable_so_dmu_snapshot_realname_fndecl_14632 dmu_snapshot_realname fndecl 4 14632 NULL
+enable_so_kmem_alloc_debug_fndecl_14852 kmem_alloc_debug fndecl 1 14852 NULL
+enable_so_kmalloc_node_nofail_fndecl_15151 kmalloc_node_nofail fndecl 1 15151 NULL
+enable_so_size_VNet_EventHeader_15382 size VNet_EventHeader 0 15382 NULL
+enable_so_dmu_write_uio_fndecl_16351 dmu_write_uio fndecl 4 16351 NULL
+enable_so_zfs_log_write_fndecl_16524 zfs_log_write fndecl 6-5 16524 NULL
+enable_so_sa_build_layouts_fndecl_16910 sa_build_layouts fndecl 3 16910 NULL
+enable_so_dsl_dir_namelen_fndecl_17053 dsl_dir_namelen fndecl 0 17053 NULL
+enable_so_kcopy_copy_to_user_fndecl_17336 kcopy_copy_to_user fndecl 5 17336 NULL
+enable_so_sa_add_layout_entry_fndecl_17507 sa_add_layout_entry fndecl 3 17507 NULL
+enable_so_sa_attr_table_setup_fndecl_18029 sa_attr_table_setup fndecl 3 18029 NULL
+enable_so_uiocopy_fndecl_18680 uiocopy fndecl 2 18680 NULL
+enable_so_dmu_buf_hold_array_by_dnode_fndecl_19125 dmu_buf_hold_array_by_dnode fndecl 2-3 19125 NULL
+enable_so_zpl_acl_from_xattr_fndecl_21141 zpl_acl_from_xattr fndecl 2 21141 NULL
+enable_so_dsl_pool_tx_assign_init_fndecl_22518 dsl_pool_tx_assign_init fndecl 2 22518 NULL
+enable_so_nvlist_lookup_byte_array_fndecl_22527 nvlist_lookup_byte_array fndecl 0 22527 NULL
+enable_so_sa_replace_all_by_template_locked_fndecl_22533 sa_replace_all_by_template_locked fndecl 3 22533 NULL
+enable_so_tsd_hash_table_init_fndecl_22559 tsd_hash_table_init fndecl 1 22559 NULL
+enable_so_spa_vdev_remove_aux_fndecl_23966 spa_vdev_remove_aux fndecl 4 23966 NULL
+enable_so_zpl_xattr_acl_set_access_fndecl_24129 zpl_xattr_acl_set_access fndecl 4 24129 NULL
+enable_so_dmu_assign_arcbuf_fndecl_24622 dmu_assign_arcbuf fndecl 2 24622 NULL
+enable_so_zap_lookup_norm_fndecl_25166 zap_lookup_norm fndecl 9 25166 NULL
+enable_so_dmu_prealloc_fndecl_25456 dmu_prealloc fndecl 4-3 25456 NULL
+enable_so_kmalloc_nofail_fndecl_26347 kmalloc_nofail fndecl 1 26347 NULL
+enable_so_zfsctl_snapshot_zpath_fndecl_27578 zfsctl_snapshot_zpath fndecl 2 27578 NULL
+enable_so_zpios_dmu_read_fndecl_30015 zpios_dmu_read fndecl 4-5 30015 NULL
+enable_so_splat_write_fndecl_30943 splat_write fndecl 3 30943 NULL
+enable_so_zpl_xattr_get_sa_fndecl_31183 zpl_xattr_get_sa fndecl 0 31183 NULL
+enable_so_dmu_read_uio_fndecl_31467 dmu_read_uio fndecl 4 31467 NULL
+enable_so_zfs_replay_fuids_fndecl_31479 zfs_replay_fuids fndecl 4 31479 NULL
+enable_so_spa_history_log_to_phys_fndecl_31632 spa_history_log_to_phys fndecl 0-1 31632 NULL
+enable_so___zpl_xattr_get_fndecl_32601 __zpl_xattr_get fndecl 0 32601 NULL
+enable_so_VNetUserListenerRead_fndecl_34039 VNetUserListenerRead fndecl 4 34039 NULL
+enable_so_proc_copyout_string_fndecl_34049 proc_copyout_string fndecl 2 34049 NULL
+enable_so_nv_alloc_sleep_spl_fndecl_34544 nv_alloc_sleep_spl fndecl 2 34544 NULL
+enable_so_nv_alloc_nosleep_spl_fndecl_34761 nv_alloc_nosleep_spl fndecl 2 34761 NULL
+enable_so_zap_leaf_array_match_fndecl_36922 zap_leaf_array_match fndecl 4 36922 NULL
+enable_so_copyinstr_fndecl_36980 copyinstr fndecl 3 36980 NULL
+enable_so_zpl_xattr_acl_set_default_fndecl_37864 zpl_xattr_acl_set_default fndecl 4 37864 NULL
+enable_so_splat_read_fndecl_38116 splat_read fndecl 3 38116 NULL
+enable_so_sa_setup_fndecl_38756 sa_setup fndecl 4 38756 NULL
+enable_so_vdev_disk_physio_fndecl_39898 vdev_disk_physio fndecl 3 39898 NULL
+enable_so_arc_buf_size_fndecl_39982 arc_buf_size fndecl 0 39982 NULL
+enable_so_kzalloc_nofail_fndecl_40719 kzalloc_nofail fndecl 1 40719 NULL
+enable_so_fuidstr_to_sid_fndecl_40777 fuidstr_to_sid fndecl 4 40777 NULL
+enable_so_vdev_raidz_matrix_reconstruct_fndecl_40852 vdev_raidz_matrix_reconstruct fndecl 2-3 40852 NULL
+enable_so_sa_find_layout_fndecl_40892 sa_find_layout fndecl 4 40892 NULL
+enable_so_zpl_xattr_get_dir_fndecl_41918 zpl_xattr_get_dir fndecl 0 41918 NULL
+enable_so_zfs_sa_get_xattr_fndecl_42600 zfs_sa_get_xattr fndecl 0 42600 NULL
+enable_so_zpl_xattr_acl_set_fndecl_42808 zpl_xattr_acl_set fndecl 4 42808 NULL
+enable_so_xdr_dec_array_fndecl_43091 xdr_dec_array fndecl 5 43091 NULL
+enable_so_dsl_dataset_namelen_fndecl_43136 dsl_dataset_namelen fndecl 0 43136 NULL
+enable_so_kcopy_write_fndecl_43683 kcopy_write fndecl 3 43683 NULL
+enable_so_uiomove_fndecl_44355 uiomove fndecl 2 44355 NULL
+enable_so_dmu_read_fndecl_44418 dmu_read fndecl 4-3 44418 NULL
+enable_so_ddi_copyin_fndecl_44846 ddi_copyin fndecl 3 44846 NULL
+enable_so_kcopy_do_get_fndecl_45061 kcopy_do_get fndecl 5 45061 NULL
+enable_so_copyin_fndecl_45945 copyin fndecl 3 45945 NULL
+enable_so_zil_itx_create_fndecl_46555 zil_itx_create fndecl 2 46555 NULL
+enable_so_dmu_write_uio_dbuf_fndecl_48064 dmu_write_uio_dbuf fndecl 3 48064 NULL
+enable_so_blk_rq_pos_fndecl_48233 blk_rq_pos fndecl 0 48233 NULL
+enable_so_spa_history_write_fndecl_49650 spa_history_write fndecl 3 49650 NULL
+enable_so_kcopy_copy_pages_to_user_fndecl_49823 kcopy_copy_pages_to_user fndecl 3-4 49823 NULL
+enable_so_zfs_log_write_fndecl_50162 zfs_log_write fndecl 6-5 50162 NULL
+enable_so_i_fm_alloc_fndecl_51038 i_fm_alloc fndecl 2 51038 NULL
+enable_so_copyout_fndecl_51409 copyout fndecl 3 51409 NULL
+enable_so_VNetKernel_MemoryAllocate_fndecl_53131 VNetKernel_MemoryAllocate fndecl 1 53131 NULL
+enable_so_VNetUserIfWrite_fndecl_54044 VNetUserIfWrite fndecl 4 54044 NULL
+enable_so_zvol_log_write_fndecl_54898 zvol_log_write fndecl 4-3 54898 NULL
+enable_so_zfs_acl_node_alloc_fndecl_55641 zfs_acl_node_alloc fndecl 1 55641 NULL
+enable_so_get_nvlist_fndecl_56685 get_nvlist fndecl 2 56685 NULL
+enable_so_zprop_get_numprops_fndecl_56820 zprop_get_numprops fndecl 0 56820 NULL
+enable_so_splat_taskq_test4_common_fndecl_59829 splat_taskq_test4_common fndecl 5 59829 NULL
+enable_so_zfs_replay_domain_cnt_fndecl_61399 zfs_replay_domain_cnt fndecl 0 61399 NULL
+enable_so_zpios_write_fndecl_61823 zpios_write fndecl 3 61823 NULL
+enable_so_proc_copyin_string_fndecl_62019 proc_copyin_string fndecl 4 62019 NULL
+enable_so_random_get_pseudo_bytes_fndecl_64611 random_get_pseudo_bytes fndecl 2 64611 NULL
+enable_so_zpios_read_fndecl_64734 zpios_read fndecl 3 64734 NULL
